
CombatPaging = LibStub("AceAddon-3.0"):NewAddon("CombatPaging", "AceConsole-3.0", "AceEvent-3.0")
local friendly = 2
local hostile = 1

function CombatPaging:OnInitialize()
    -- initialize

    defaultButtonValues = {
        1,2,3,4,5,6
	}

    databaseDefaults = {
		global = {
		  version = "1.0.0",
		},
		profile = {
			bindings = {
				friendly = {
					value = 2,
				},
				hostile = {
					value = 1,
				},
			},
		  }
	}

	CombatPagingOptions = { 
		name = "Combat Paging Settings",
		
		handler = CombatPaging,
		type = "group",
		args = {
			friendly = {
				name = "Friendly Action Bar",
				desc = "Friendly Action Bar",
				type = "select",
				width = "full",
				order = 1,
				values = defaultButtonValues,
                set = function(info, value)
                    print ("Value is")
                    print (info)
					self.db.profile.bindings.friendly.value = value
				end,
				get = function()
					return self.db.profile.bindings.friendly.value
				end
			},
			hostile = {
				name = "Hostile Action Bar",
				desc = "Hostile Action Bar",
				type = "select",
				width = "full",
				order = 2,
				values = defaultButtonValues,
				set = function(info, value)
					self.db.profile.bindings.hostile.value = value
				end,
				get = function()
					return self.db.profile.bindings.hostile.value
				end
			}
		}		
	}
		
	self.db = LibStub("AceDB-3.0"):New("CombatPagingDB")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("Combat Paging", CombatPagingOptions)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Combat Paging", "Combat Paging")
    self:RegisterChatCommand("cp", "ChatCommand")
    self:RegisterChatCommand("combatPaging", "ChatCommand")
	self.db = LibStub("AceDB-3.0"):New("CombatPagingDB", databaseDefaults, true)

end

function CombatPaging:OnEnable()
    -- Register Events
    self:RegisterEvent("PLAYER_TARGET_CHANGED", CombatPaging_OnEvent)
end

function CombatPaging:OnDisable()
    -- Called when the addon is disabled
end

function CombatPaging:setValues()
    friendly = self.db.profile.bindings.friendly.value
    hostile = self.db.profile.bindings.hostile.value
end

function CombatPaging:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0"):HandleCommand("cp", "CombatPaging", input)
    end
end

function CombatPaging_OnEvent(event, ...)
    CombatPaging:setValues()

    if event == "PLAYER_TARGET_CHANGED" then			
        -- target changed	
        if UnitExists("target") and UnitIsFriend("player", "target") then	
            -- unit is friendly
            ChangeActionBarPage(friendly);
        else
            -- unit is hostile
            ChangeActionBarPage(hostile);
        end
    end
end

function CombatPaging_OnUpdate(self, elapsed)
	-- update code
end

function CombatPaging_OnLoad(self, elapsed)
end